Module GOST_UODAT
  ' This is an re-implementation of the GOST cipher as modified by OSI


  ' First array = 6 bytes, second array = &H44 items
  Private SillyIndexTable() As UInt64 = {&HF7AA4C98L, &HBF62C067L, &HB524334L, &HBC28A2D0L, &H6B57C2D1L, &H233843AAL, &HC06D0210L, &H38D4F804L}
  Private SillyScriptTable() As Integer = {6, 5, 4, 3, 4, 5, 4, 3, 4, 5, 4, 3, 4, 5, 4, 3, 4, 6, 5, 4, 3, 4, 5, 4, 3, 4, 5, 4, 3, 4, 5, 4, 3, 4, 6, 5, 4, 3, 4, 5, 4, 3, 4, 5, 4, 3, 4, 5, 4, 3, 4, 2, 1, 2, 0, 2, 1, 2, 0, 2, 1, 2, 0, 2, 1, 2, 0, 2}

  ' Array size = 256 items
  Dim SillyValueList1() As UInt32 = {&HE4L, &HEAL, &HE9L, &HE2L, &HEDL, &HE8L, &HE0L, &HEEL, &HE6L, &HEBL, &HE1L, &HECL, &HE7L, &HEFL, &HE5L, &HE3L, &HB4L, &HBAL, &HB9L, &HB2L, &HBDL, &HB8L, &HB0L, &HBEL, &HB6L, &HBBL, &HB1L, &HBCL, &HB7L, &HBFL, &HB5L, &HB3L, &H44L, &H4AL, &H49L, &H42L, &H4DL, &H48L, &H40L, &H4EL, &H46L, &H4BL, &H41L, &H4CL, &H47L, &H4FL, &H45L, &H43L, &HC4L, &HCAL, &HC9L, &HC2L, &HCDL, &HC8L, &HC0L, &HCEL, &HC6L, &HCBL, &HC1L, &HCCL, &HC7L, &HCFL, &HC5L, &HC3L, &H64L, &H6AL, &H69L, &H62L, &H6DL, &H68L, &H60L, &H6EL, &H66L, &H6BL, &H61L, &H6CL, &H67L, &H6FL, &H65L, &H63L, &HD4L, &HDAL, &HD9L, &HD2L, &HDDL, &HD8L, &HD0L, &HDEL, &HD6L, &HDBL, &HD1L, &HDCL, &HD7L, &HDFL, &HD5L, &HD3L, &HF4L, &HFAL, &HF9L, &HF2L, &HFDL, &HF8L, &HF0L, &HFEL, &HF6L, &HFBL, &HF1L, &HFCL, &HF7L, &HFFL, &HF5L, &HF3L, &HA4L, &HAAL, &HA9L, &HA2L, &HADL, &HA8L, &HA0L, &HAEL, &HA6L, &HABL, &HA1L, &HACL, &HA7L, &HAFL, &HA5L, &HA3L, &H24L, &H2AL, &H29L, &H22L, &H2DL, &H28L, &H20L, &H2EL, &H26L, &H2BL, &H21L, &H2CL, &H27L, &H2FL, &H25L, &H23L, &H34L, &H3AL, &H39L, &H32L, &H3DL, &H38L, &H30L, &H3EL, &H36L, &H3BL, &H31L, &H3CL, &H37L, &H3FL, &H35L, &H33L, &H84L, &H8AL, &H89L, &H82L, &H8DL, &H88L, &H80L, &H8EL, &H86L, &H8BL, &H81L, &H8CL, &H87L, &H8FL, &H85L, &H83L, &H14L, &H1AL, &H19L, &H12L, &H1DL, &H18L, &H10L, &H1EL, &H16L, &H1BL, &H11L, &H1CL, &H17L, &H1FL, &H15L, &H13L, &H4L, &HAL, &H9L, &H2L, &HDL, &H8L, &H0L, &HEL, &H6L, &HBL, &H1L, &HCL, &H7L, &HFL, &H5L, &H3L, &H74L, &H7AL, &H79L, &H72L, &H7DL, &H78L, &H70L, &H7EL, &H76L, &H7BL, &H71L, &H7CL, &H77L, &H7FL, &H75L, &H73L, &H54L, &H5AL, &H59L, &H52L, &H5DL, &H58L, &H50L, &H5EL, &H56L, &H5BL, &H51L, &H5CL, &H57L, &H5FL, &H55L, &H53L, &H94L, &H9AL, &H99L, &H92L, &H9DL, &H98L, &H90L, &H9EL, &H96L, &H9BL, &H91L, &H9CL, &H97L, &H9FL, &H95L, &H93L}
  Dim SillyValueList2() As UInt32 = {&H7500L, &H7800L, &H7100L, &H7D00L, &H7A00L, &H7300L, &H7400L, &H7200L, &H7E00L, &H7F00L, &H7C00L, &H7700L, &H7600L, &H7000L, &H7900L, &H7B00L, &HD500L, &HD800L, &HD100L, &HDD00L, &HDA00L, &HD300L, &HD400L, &HD200L, &HDE00L, &HDF00L, &HDC00L, &HD700L, &HD600L, &HD000L, &HD900L, &HDB00L, &HA500L, &HA800L, &HA100L, &HAD00L, &HAA00L, &HA300L, &HA400L, &HA200L, &HAE00L, &HAF00L, &HAC00L, &HA700L, &HA600L, &HA000L, &HA900L, &HAB00L, &H1500L, &H1800L, &H1100L, &H1D00L, &H1A00L, &H1300L, &H1400L, &H1200L, &H1E00L, &H1F00L, &H1C00L, &H1700L, &H1600L, &H1000L, &H1900L, &H1B00L, &H500L, &H800L, &H100L, &HD00L, &HA00L, &H300L, &H400L, &H200L, &HE00L, &HF00L, &HC00L, &H700L, &H600L, &H0L, &H900L, &HB00L, &H8500L, &H8800L, &H8100L, &H8D00L, &H8A00L, &H8300L, &H8400L, &H8200L, &H8E00L, &H8F00L, &H8C00L, &H8700L, &H8600L, &H8000L, &H8900L, &H8B00L, &H9500L, &H9800L, &H9100L, &H9D00L, &H9A00L, &H9300L, &H9400L, &H9200L, &H9E00L, &H9F00L, &H9C00L, &H9700L, &H9600L, &H9000L, &H9900L, &H9B00L, &HF500L, &HF800L, &HF100L, &HFD00L, &HFA00L, &HF300L, &HF400L, &HF200L, &HFE00L, &HFF00L, &HFC00L, &HF700L, &HF600L, &HF000L, &HF900L, &HFB00L, &HE500L, &HE800L, &HE100L, &HED00L, &HEA00L, &HE300L, &HE400L, &HE200L, &HEE00L, &HEF00L, &HEC00L, &HE700L, &HE600L, &HE000L, &HE900L, &HEB00L, &H4500L, &H4800L, &H4100L, &H4D00L, &H4A00L, &H4300L, &H4400L, &H4200L, &H4E00L, &H4F00L, &H4C00L, &H4700L, &H4600L, &H4000L, &H4900L, &H4B00L, &H6500L, &H6800L, &H6100L, &H6D00L, &H6A00L, &H6300L, &H6400L, &H6200L, &H6E00L, &H6F00L, &H6C00L, &H6700L, &H6600L, &H6000L, &H6900L, &H6B00L, &HC500L, &HC800L, &HC100L, &HCD00L, &HCA00L, &HC300L, &HC400L, &HC200L, &HCE00L, &HCF00L, &HCC00L, &HC700L, &HC600L, &HC000L, &HC900L, &HCB00L, &HB500L, &HB800L, &HB100L, &HBD00L, &HBA00L, &HB300L, &HB400L, &HB200L, &HBE00L, &HBF00L, &HBC00L, &HB700L, &HB600L, &HB000L, &HB900L, &HBB00L, &H2500L, &H2800L, &H2100L, &H2D00L, &H2A00L, &H2300L, &H2400L, &H2200L, &H2E00L, &H2F00L, &H2C00L, &H2700L, &H2600L, &H2000L, &H2900L, &H2B00L, &H5500L, &H5800L, &H5100L, &H5D00L, &H5A00L, &H5300L, &H5400L, &H5200L, &H5E00L, &H5F00L, &H5C00L, &H5700L, &H5600L, &H5000L, &H5900L, &H5B00L, &H3500L, &H3800L, &H3100L, &H3D00L, &H3A00L, &H3300L, &H3400L, &H3200L, &H3E00L, &H3F00L, &H3C00L, &H3700L, &H3600L, &H3000L, &H3900L, &H3B00L}
  Dim SillyValueList3() As UInt32 = {&H460000L, &H4C0000L, &H470000L, &H410000L, &H450000L, &H4F0000L, &H4D0000L, &H480000L, &H440000L, &H4A0000L, &H490000L, &H4E0000L, &H400000L, &H430000L, &H4B0000L, &H420000L, &HB60000L, &HBC0000L, &HB70000L, &HB10000L, &HB50000L, &HBF0000L, &HBD0000L, &HB80000L, &HB40000L, &HBA0000L, &HB90000L, &HBE0000L, &HB00000L, &HB30000L, &HBB0000L, &HB20000L, &HA60000L, &HAC0000L, &HA70000L, &HA10000L, &HA50000L, &HAF0000L, &HAD0000L, &HA80000L, &HA40000L, &HAA0000L, &HA90000L, &HAE0000L, &HA00000L, &HA30000L, &HAB0000L, &HA20000L, &H60000L, &HC0000L, &H70000L, &H10000L, &H50000L, &HF0000L, &HD0000L, &H80000L, &H40000L, &HA0000L, &H90000L, &HE0000L, &H0L, &H30000L, &HB0000L, &H20000L, &H760000L, &H7C0000L, &H770000L, &H710000L, &H750000L, &H7F0000L, &H7D0000L, &H780000L, &H740000L, &H7A0000L, &H790000L, &H7E0000L, &H700000L, &H730000L, &H7B0000L, &H720000L, &H260000L, &H2C0000L, &H270000L, &H210000L, &H250000L, &H2F0000L, &H2D0000L, &H280000L, &H240000L, &H2A0000L, &H290000L, &H2E0000L, &H200000L, &H230000L, &H2B0000L, &H220000L, &H160000L, &H1C0000L, &H170000L, &H110000L, &H150000L, &H1F0000L, &H1D0000L, &H180000L, &H140000L, &H1A0000L, &H190000L, &H1E0000L, &H100000L, &H130000L, &H1B0000L, &H120000L, &HD60000L, &HDC0000L, &HD70000L, &HD10000L, &HD50000L, &HDF0000L, &HDD0000L, &HD80000L, &HD40000L, &HDA0000L, &HD90000L, &HDE0000L, &HD00000L, &HD30000L, &HDB0000L, &HD20000L, &H360000L, &H3C0000L, &H370000L, &H310000L, &H350000L, &H3F0000L, &H3D0000L, &H380000L, &H340000L, &H3A0000L, &H390000L, &H3E0000L, &H300000L, &H330000L, &H3B0000L, &H320000L, &H660000L, &H6C0000L, &H670000L, &H610000L, &H650000L, &H6F0000L, &H6D0000L, &H680000L, &H640000L, &H6A0000L, &H690000L, &H6E0000L, &H600000L, &H630000L, &H6B0000L, &H620000L, &H860000L, &H8C0000L, &H870000L, &H810000L, &H850000L, &H8F0000L, &H8D0000L, &H880000L, &H840000L, &H8A0000L, &H890000L, &H8E0000L, &H800000L, &H830000L, &H8B0000L, &H820000L, &H560000L, &H5C0000L, &H570000L, &H510000L, &H550000L, &H5F0000L, &H5D0000L, &H580000L, &H540000L, &H5A0000L, &H590000L, &H5E0000L, &H500000L, &H530000L, &H5B0000L, &H520000L, &H960000L, &H9C0000L, &H970000L, &H910000L, &H950000L, &H9F0000L, &H9D0000L, &H980000L, &H940000L, &H9A0000L, &H990000L, &H9E0000L, &H900000L, &H930000L, &H9B0000L, &H920000L, &HC60000L, &HCC0000L, &HC70000L, &HC10000L, &HC50000L, &HCF0000L, &HCD0000L, &HC80000L, &HC40000L, &HCA0000L, &HC90000L, &HCE0000L, &HC00000L, &HC30000L, &HCB0000L, &HC20000L, &HF60000L, &HFC0000L, &HF70000L, &HF10000L, &HF50000L, &HFF0000L, &HFD0000L, &HF80000L, &HF40000L, &HFA0000L, &HF90000L, &HFE0000L, &HF00000L, &HF30000L, &HFB0000L, &HF20000L, &HE60000L, &HEC0000L, &HE70000L, &HE10000L, &HE50000L, &HEF0000L, &HED0000L, &HE80000L, &HE40000L, &HEA0000L, &HE90000L, &HEE0000L, &HE00000L, &HE30000L, &HEB0000L, &HE20000L}
  Dim SillyValueList4() As UInt32 = {&H1D000000L, &H1B000000L, &H14000000L, &H11000000L, &H13000000L, &H1F000000L, &H15000000L, &H19000000L, &H10000000L, &H1A000000L, &H1E000000L, &H17000000L, &H16000000L, &H18000000L, &H12000000L, &H1C000000L, &HFD000000L, &HFB000000L, &HF4000000L, &HF1000000L, &HF3000000L, &HFF000000L, &HF5000000L, &HF9000000L, &HF0000000L, &HFA000000L, &HFE000000L, &HF7000000L, &HF6000000L, &HF8000000L, &HF2000000L, &HFC000000L, &HDD000000L, &HDB000000L, &HD4000000L, &HD1000000L, &HD3000000L, &HDF000000L, &HD5000000L, &HD9000000L, &HD0000000L, &HDA000000L, &HDE000000L, &HD7000000L, &HD6000000L, &HD8000000L, &HD2000000L, &HDC000000L, &HD000000L, &HB000000L, &H4000000L, &H1000000L, &H3000000L, &HF000000L, &H5000000L, &H9000000L, &H0L, &HA000000L, &HE000000L, &H7000000L, &H6000000L, &H8000000L, &H2000000L, &HC000000L, &H5D000000L, &H5B000000L, &H54000000L, &H51000000L, &H53000000L, &H5F000000L, &H55000000L, &H59000000L, &H50000000L, &H5A000000L, &H5E000000L, &H57000000L, &H56000000L, &H58000000L, &H52000000L, &H5C000000L, &H7D000000L, &H7B000000L, &H74000000L, &H71000000L, &H73000000L, &H7F000000L, &H75000000L, &H79000000L, &H70000000L, &H7A000000L, &H7E000000L, &H77000000L, &H76000000L, &H78000000L, &H72000000L, &H7C000000L, &HAD000000L, &HAB000000L, &HA4000000L, &HA1000000L, &HA3000000L, &HAF000000L, &HA5000000L, &HA9000000L, &HA0000000L, &HAA000000L, &HAE000000L, &HA7000000L, &HA6000000L, &HA8000000L, &HA2000000L, &HAC000000L, &H4D000000L, &H4B000000L, &H44000000L, &H41000000L, &H43000000L, &H4F000000L, &H45000000L, &H49000000L, &H40000000L, &H4A000000L, &H4E000000L, &H47000000L, &H46000000L, &H48000000L, &H42000000L, &H4C000000L, &H9D000000L, &H9B000000L, &H94000000L, &H91000000L, &H93000000L, &H9F000000L, &H95000000L, &H99000000L, &H90000000L, &H9A000000L, &H9E000000L, &H97000000L, &H96000000L, &H98000000L, &H92000000L, &H9C000000L, &H2D000000L, &H2B000000L, &H24000000L, &H21000000L, &H23000000L, &H2F000000L, &H25000000L, &H29000000L, &H20000000L, &H2A000000L, &H2E000000L, &H27000000L, &H26000000L, &H28000000L, &H22000000L, &H2C000000L, &H3D000000L, &H3B000000L, &H34000000L, &H31000000L, &H33000000L, &H3F000000L, &H35000000L, &H39000000L, &H30000000L, &H3A000000L, &H3E000000L, &H37000000L, &H36000000L, &H38000000L, &H32000000L, &H3C000000L, &HED000000L, &HEB000000L, &HE4000000L, &HE1000000L, &HE3000000L, &HEF000000L, &HE5000000L, &HE9000000L, &HE0000000L, &HEA000000L, &HEE000000L, &HE7000000L, &HE6000000L, &HE8000000L, &HE2000000L, &HEC000000L, &H6D000000L, &H6B000000L, &H64000000L, &H61000000L, &H63000000L, &H6F000000L, &H65000000L, &H69000000L, &H60000000L, &H6A000000L, &H6E000000L, &H67000000L, &H66000000L, &H68000000L, &H62000000L, &H6C000000L, &HBD000000L, &HBB000000L, &HB4000000L, &HB1000000L, &HB3000000L, &HBF000000L, &HB5000000L, &HB9000000L, &HB0000000L, &HBA000000L, &HBE000000L, &HB7000000L, &HB6000000L, &HB8000000L, &HB2000000L, &HBC000000L, &H8D000000L, &H8B000000L, &H84000000L, &H81000000L, &H83000000L, &H8F000000L, &H85000000L, &H89000000L, &H80000000L, &H8A000000L, &H8E000000L, &H87000000L, &H86000000L, &H88000000L, &H82000000L, &H8C000000L, &HCD000000L, &HCB000000L, &HC4000000L, &HC1000000L, &HC3000000L, &HCF000000L, &HC5000000L, &HC9000000L, &HC0000000L, &HCA000000L, &HCE000000L, &HC7000000L, &HC6000000L, &HC8000000L, &HC2000000L, &HCC000000L}

  Private Function UODAT_f(ByVal Index As UInt32) As UInt32
    Dim EAX As UInt64 = _
                        SillyValueList1(Index >> 0 And &HFF) _
                      + SillyValueList2(Index >> 8 And &HFF) _
                      + SillyValueList3(Index >> 16 And &HFF) _
                      + SillyValueList4(Index >> 24 And &HFF)
    EAX = EAX And &HFFFFFFFFL
    Return ((EAX << 11) And &HFFFFFFFFL) Or (EAX >> 21) ' rol EAX, 0x0B
  End Function

  Private Sub UODAT_Execute(ByVal ExecutionCode As Integer, ByRef ECX As UInt32, ByRef EDX As UInt32, ByRef EBX As Int32)
    Select Case ExecutionCode
      Case 0, 3
        Dim tmp As UInt64 = SillyIndexTable(EBX) + ECX
        EDX = EDX Xor UODAT_f(tmp And &HFFFFFFFFL)
      Case 1, 5
        Dim tmp As UInt64 = SillyIndexTable(EBX) + EDX
        ECX = ECX Xor UODAT_f(tmp And &HFFFFFFFFL)
      Case 2
        EBX -= 1
      Case 4
        EBX += 1
      Case 6
        EBX = 0
      Case Else
        Throw New Exception("UODAT_Execute, invalid execution code: " & ExecutionCode)
    End Select
  End Sub

  Public Sub UODAT_gostencrypt(ByRef inarray() As UInt32, ByRef outarray() As UInt32)
    Dim EDX As UInt32 = inarray(0)
    Dim ECX As UInt32 = inarray(1)
    Dim EBX As Int32

    For i As Integer = SillyScriptTable.GetLowerBound(0) To SillyScriptTable.GetUpperBound(0)
      Call UODAT_Execute(SillyScriptTable(i), ECX, EDX, EBX)
    Next

    outarray(0) = ECX
    outarray(1) = EDX
  End Sub

  ' The constants for addition 
  Private Const C1 As UInt32 = &H1010104L
  Private Const C2 As UInt32 = &H1010101L

  '
  Public Sub UODAT_gostofb(ByRef inarray() As UInt32, ByRef outarray() As UInt32, ByVal len As Integer)
    Dim temp(0 To 1) As UInt32
    Dim gamma(0 To 1) As UInt32

    ' IV is fixed in OSI's implementation
    Dim iv() As UInt32 = {&H591DCB84L, &HCBA84B2CL}
    Call UODAT_gostencrypt(iv, temp)

    ' Execute
    Dim index As Integer = 0
    For len = len To 1 Step -1
      temp(0) = (CType(temp(0), UInt64) + C2) And &HFFFFFFFFL
      If temp(0) < C2 Then ' Wrap modulo 2^32?
        temp(0) += 1       ' Make it modulo 2^32-1 
      End If
      temp(1) = (CType(temp(1), UInt64) + C1) And &HFFFFFFFFL
      If temp(1) < C1 Then ' Wrap modulo 2^32?
        temp(1) += 1       ' Make it modulo 2^32-1
      End If

      Call UODAT_gostencrypt(temp, gamma)

      outarray(index) = inarray(index) Xor gamma(0)
      index = index + 1
      outarray(index) = inarray(index) Xor gamma(1)
      index = index + 1
    Next

    Return
  End Sub
End Module
